#include <iostream>  
#include <assert.h>  
using namespace std;

#define MAXSTR 300


struct url_t {

	char uri[MAXSTR]; //This stores the actual address e.g., "https://www.tamu.edu"
	bool is_bookmarked; // True iff this is a fav.

	url_t *link; // The previous url we visited

};

url_t *top = NULL;


void url_print(url_t *u)
{
	if (u != NULL)
	{
		cout << u->uri;
		if (u->is_bookmarked)
			cout << " * ";
		cout << endl;
	}
	else

		cout << "(null url)" << endl;
}

bool get_bool()
{
	while (true)
	{
		char c;
		cin >> c;
		switch (c)
		{
			case 'y':
			case 'Y': return true;
			case 'n':
			case 'N': return false; 
			default:
				cerr << "Please enter Y or N!" << endl;
		}
	}

}

url_t *url_new()
{
	url_t *ret = new url_t;

	cout << "Enter URL: " << endl;
	cin >> ret->uri;
	cout << "Is this a favorite?: " << endl;
	ret->is_bookmarked = get_bool();

	ret->link = NULL;

	return ret;
}
	

void url_destroy(url_t *u)
{
	assert(u != NULL);

	delete u;
}


bool is_stack_empty()
{
	return	(top == NULL);
}

void push(url_t *u)
{
	assert(u != NULL);
	u->link = top;
	top = u;
}

url_t *pop()
{ // This should remove the element from the top of our stack
  // and return that element.
	
	assert(top != NULL);

	url_t *former_top = top;
	top = top->link;
	former_top->link = NULL;
	return former_top;
}

void stack_print()
{
	// This navigates the stack, starting at the top and progressing downwards, printing each element.
	if (top == NULL)
	{
		cout << "The stack is empty" << endl;
	}
	else
	{
		int counter = 0;
		url_t *walker = top;
		while (walker != NULL)
		{
			cout << "#" << counter++ << ": ";
			url_print(walker);
			walker = walker->link; // move down the chain
		}

	}

}


void stack_destroy()
{
	while (!is_stack_empty())
		url_destroy(pop());

}

int main(int argc, char **argv)
{
	url_t *homepage = NULL;

	cout << "Let's start with your homepage---";
	homepage = url_new();


	// do stuff with it
	
	push(homepage);	
	push(url_new());	
	push(url_new());	

	cout << "First print" << endl;
	stack_print();

	url_t *last = pop();

	cout << "Second print" << endl;
	stack_print();

	url_destroy(last);

	stack_destroy();


	return 0;
}

